'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MEDIA_PREFIX = exports.MEDIA_PREFIX = '@media';

// -----------------------------------------------------------------------------
// CONFIG
// -----------------------------------------------------------------------------

var SEPARATOR_VALUES = exports.SEPARATOR_VALUES = Object.freeze({
  rem: 0.01,
  em: 0.01,
  px: 1,
  dpi: 1
});

var DIMENSIONS_UNITS = exports.DIMENSIONS_UNITS = Object.freeze({
  EM: 'em',
  REM: 'rem',
  PX: 'px'
});

var RESOLUTION_UNIT = exports.RESOLUTION_UNIT = 'dpi';

var UNITS = exports.UNITS = Object.freeze({
  DIMENSIONS: DIMENSIONS_UNITS,
  RESOLUTION: Object.freeze({ DPI: 'dpi' })
});

var BREAKPOINT_MAP_NAMES = exports.BREAKPOINT_MAP_NAMES = Object.freeze(['width', 'height', 'resolution']);

// -----------------------------------------------------------------------------
// MEDIA TYPES
// -----------------------------------------------------------------------------

var MEDIA_TYPES = exports.MEDIA_TYPES = Object.freeze({
  ALL: 'all',
  PRINT: 'print',
  SCREEN: 'screen',
  SPEECH: 'speech'
});