'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _predicates = require('../utils/predicates');

var _validations = require('../validations');

var _queryRenderer = require('../renderers/cssRenderers/queryRenderer');

exports.default = function (name, possibleValues) {
  var allowNoArgument = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return function (value) {
    (0, _ramda.unless)((0, _ramda.both)(_predicates.isUndefined, (0, _ramda.always)(allowNoArgument)), (0, _ramda.partial)(_validations.validateFeature, [name, possibleValues]))(value);
    return (0, _queryRenderer.renderFeature)(name, value);
  };
};