'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _validations = require('../validations');

var _string = require('../utils/string');

var _array = require('../utils/array');

exports.default = function (defaultMediaType) {
  return function () {
    var mediaTypes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [defaultMediaType];

    var mediaTypesArray = (0, _array.ensureArray)(mediaTypes);
    (0, _validations.validateMediaTypes)(mediaTypesArray);
    return (0, _string.toCommaSeparatedList)(mediaTypesArray);
  };
};