'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _units = require('../../utils/units');

var _const = require('../../const');

var _predicates = require('../../utils/predicates');

var toUnit = function toUnit(dimensionsUnit, baseFontSize) {
  return (0, _ramda.partial)(_units.toDimensionOutput, [dimensionsUnit, baseFontSize]);
};

var prepareUnitlessValue = function prepareUnitlessValue(value, shouldSeparateQueries, dimensionsUnit) {
  return (0, _ramda.when)((0, _ramda.always)(shouldSeparateQueries), (0, _ramda.subtract)(_ramda.__, (0, _units.separatorValueForUnit)(dimensionsUnit)))(value);
};

exports.default = function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$baseFontSize = _ref.baseFontSize,
      baseFontSize = _ref$baseFontSize === undefined ? 16 : _ref$baseFontSize,
      _ref$dimensionsUnit = _ref.dimensionsUnit,
      dimensionsUnit = _ref$dimensionsUnit === undefined ? _const.UNITS.DIMENSIONS.EM : _ref$dimensionsUnit,
      _ref$shouldSeparateQu = _ref.shouldSeparateQueries,
      shouldSeparateQueries = _ref$shouldSeparateQu === undefined ? true : _ref$shouldSeparateQu;

  return function (value, shouldSeparate) {
    if ((0, _predicates.isNumberWithDimensionsUnit)(value)) {
      value = (0, _units.unitedDimensionToUnitlessPixelValue)(value, baseFontSize);
    }
    var preparedValue = prepareUnitlessValue(value, shouldSeparateQueries && shouldSeparate, dimensionsUnit);
    var x = toUnit(dimensionsUnit, baseFontSize)(preparedValue);
    return x;
  };
};