'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _units = require('../../utils/units');

var _predicates = require('../../utils/predicates');

var _const = require('../../const');

var prepareUnitlessValue = function prepareUnitlessValue(value, shouldSeparateQueries, unit) {
  return (0, _ramda.when)((0, _ramda.always)(shouldSeparateQueries), (0, _ramda.subtract)(_ramda.__, (0, _units.separatorValueForUnit)(unit)))(value);
};

exports.default = function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$shouldSeparateQu = _ref.shouldSeparateQueries,
      shouldSeparateQueries = _ref$shouldSeparateQu === undefined ? true : _ref$shouldSeparateQu;

  return function (value, shouldSeparate) {
    if ((0, _predicates.isNumberWithResolutionUnit)(value)) {
      value = (0, _units.unitedResolutionToUnitlessValue)(value);
    }

    var preparedValue = prepareUnitlessValue(value, shouldSeparateQueries && shouldSeparate, _const.UNITS.RESOLUTION.DPI);

    return (0, _units.appendUnit)(preparedValue, _const.UNITS.RESOLUTION.DPI);
  };
};