'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUpperLimit = exports.toBreakpointArray = exports.propEqName = undefined;

var _ramda = require('ramda');

// -----------------------------------------------------------------------------
// Internal
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Exports
// -----------------------------------------------------------------------------

var propEqName = exports.propEqName = (0, _ramda.propEq)('name');
var propName = (0, _ramda.prop)('name');
var zipToNameAndValue = (0, _ramda.zipObj)(['name', 'value']);
// TODO: This should be internal
var findBreakpointIndex = function findBreakpointIndex(breakpoint, breakpointsArray) {
  return (0, _ramda.findIndex)(propEqName(breakpoint))(breakpointsArray);
};

var toBreakpointArray = exports.toBreakpointArray = (0, _ramda.compose)((0, _ramda.map)(zipToNameAndValue), _ramda.toPairs);

var getUpperLimit = exports.getUpperLimit = function getUpperLimit(breakpointsArray, breakpoint) {
  var index = findBreakpointIndex(breakpoint, breakpointsArray);
  return (0, _ramda.compose)(propName, (0, _ramda.nth)((0, _ramda.inc)(index)))(breakpointsArray);
};