'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unitedResolutionToUnitlessValue = exports.unitedDimensionToUnitlessPixelValue = exports.unitPartOfUnitedNumber = exports.numericPartOfUnitedNumber = exports.elementsOfUnitedNumber = exports.toDimensionOutput = exports.remOrEmToPxValue = exports.pxToRemOrEmValue = exports.unitIsRemOrEm = exports.appendUnit = exports.separatorValueForUnit = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ramda = require('ramda');

var _const = require('../const');

var separatorValueForUnit = exports.separatorValueForUnit = function separatorValueForUnit(unit) {
  return _const.SEPARATOR_VALUES[unit];
};

var appendUnit = exports.appendUnit = function appendUnit(value, unit) {
  return (0, _ramda.join)('', [value, unit]);
};

var unitIsRemOrEm = exports.unitIsRemOrEm = (0, _ramda.contains)(_ramda.__, [_const.UNITS.DIMENSIONS.EM, _const.UNITS.DIMENSIONS.REM]);

var pxToRemOrEmValue = exports.pxToRemOrEmValue = function pxToRemOrEmValue(value, baseFontSize) {
  return (0, _ramda.divide)(value, baseFontSize);
};

var remOrEmToPxValue = exports.remOrEmToPxValue = function remOrEmToPxValue(value, baseFontSize) {
  return (0, _ramda.multiply)(value, baseFontSize);
};

var toDimensionOutput = exports.toDimensionOutput = function toDimensionOutput(unit, baseFontSize, value) {
  return appendUnit(unitIsRemOrEm(unit) ? pxToRemOrEmValue(value, baseFontSize) : value, unit);
};

var elementsOfUnitedNumber = exports.elementsOfUnitedNumber = function elementsOfUnitedNumber(value) {
  var captures = /^(-?\d+(?:.\d+)?)([a-z]+)?$/.exec(value);
  if ((0, _ramda.none)((0, _ramda.complement)(_ramda.isNil), [captures, captures[1], captures[2]])) {
    throw new Error('You can\'t get the numeric portion of \'' + value + '\'');
  }
  return [Number(captures[1]), captures[2]];
};

var numericPartOfUnitedNumber = exports.numericPartOfUnitedNumber = (0, _ramda.compose)((0, _ramda.view)((0, _ramda.lensIndex)(0)), elementsOfUnitedNumber);

var unitPartOfUnitedNumber = exports.unitPartOfUnitedNumber = (0, _ramda.compose)((0, _ramda.view)((0, _ramda.lensIndex)(1)), elementsOfUnitedNumber);

var unitedDimensionToUnitlessPixelValue = exports.unitedDimensionToUnitlessPixelValue = function unitedDimensionToUnitlessPixelValue(value, baseFontSize) {
  var _elementsOfUnitedNumb = elementsOfUnitedNumber(value),
      _elementsOfUnitedNumb2 = _slicedToArray(_elementsOfUnitedNumb, 2),
      number = _elementsOfUnitedNumb2[0],
      unit = _elementsOfUnitedNumb2[1];

  return unitIsRemOrEm(unit) ? remOrEmToPxValue(number, baseFontSize) : number;
};

var unitedResolutionToUnitlessValue = exports.unitedResolutionToUnitlessValue = function unitedResolutionToUnitlessValue(value) {
  return numericPartOfUnitedNumber(value);
};